<?php
namespace tx;

include 'TxDemo.php';
include 'TxClient.php';
//include '../config/DemoConfig.php';
include '../util/DemoSM2Utils.php';
include '../util/DemoSM4Utils.php';
include '../util/TxUtils.php';
include '../vo/BizParameter.php';


require_once __DIR__ . '/../../vendor/autoload.php';

use tx\TxDemo;
use util\DemoSM4Utils;
use util\TxUtils;
use vo\BizParameter;
use TxClient;
/**
 * 【消费申请】
 *
 * @author 邵鉴
 * @version 1.0
 * @date 2024/10/22
 */
class Tx2085Demo extends TxDemo
{
    public static function main()
    {
        new Tx2085Demo();
        $demoConfig = self::$demoConfig;
        // 支付模式
        $bankCardNo = DemoSM4Utils::encryptEcb($demoConfig->getSecretKey(), "6212261001029054530");

        // 终端信息
        $terminfo = [
            "termno" => "12345678",
            "devicetype" => "11",
            "termsn" => "1231323",
            "location" => "+11.345676/-113.56565",
            "deviceip" => "192.168.10.2",
            "encryptrandnum" => "882544"
        ];

        // 微信正扫
        $SCAN_WEIXIN = [
            "vspCusid" => "6602900421400PJ",
            "limitPay" => "no_credit"
        ];

        // 微信公众号支付
        $WECHAT_PUBLIC = [
            "vspCusid" => "6602900421400PJ",
            "limitPay" => "no_credit",
            "acct" => "wx41a7349a679ab689"
        ];

        // 收付通协议支付
        $QUICKPAY_SFT = [
            "bankCardNo" => DemoSM4Utils::encryptEcb(self::$demoConfig->getSecretKey(), "622002007262307519"),
            "agreementNo" => "AIP751924022017D7CCCA6",
            "validate" => "1299",
            "cvv2" => "333"
        ];

        // 收银宝快捷支付
        $QUICKPAY_VSP = [
            "bankCardNo" => DemoSM4Utils::encryptEcb(self::$demoConfig->getSecretKey(), "6225220113999387"),
            "agreementNo" => "AIP61922404253A22DCAE6",
            "validate" => "1299",
            "cvv2" => "333"
        ];

        // 微信小程序
        $WECHATPAY_MINIPROGRAM = [
            "vspCusid" => "6602900421400PJ",
            "limitPay" => "no_credit",
            "acct" => "wx41a7349a679ab689"
        ];

        // 付款码支付
        $CODEPAY_VSP = [
            "vspCusid" => "6602900421400PJ",
            "limitPay" => "no_credit",
            "authcode" => "133645516383190685",
            "termInfo" => $terminfo
        ];

        // 支付宝正扫
        $SCAN_ALIPAY = [
            "vspCusid" => "6602900421400PJ",
            "limitPay" => "no_credit"
        ];

        // 银联扫码支付
        $SCAN_UNIONPAY = [
            "vspCusid" => "6602900421400PJ",
            "limitPay" => "no_credit"
        ];

        // 支付宝JS
        $ALIPAY_SERVICE = [
            "vspCusid" => "6602900421400PJ",
            "limitPay" => "no_credit",
            "acct" => "wx41a7349a679ab689"
        ];

        // 银联JS
        $UNIONPAY_JS = [
            "vspCusid" => "6602900421400PJ",
            "limitPay" => "no_credit",
            "acct" => "wx41a7349a679ab689",
            "cusIp" => "10.2.168.34"
        ];

        // 收银宝POS
        $ORDER_VSPPAY = [
            "vspCusid" => "6602900421400PJ",
            "trxReserve" => "#李平# 金湖路55号#18916507392#0#411423198708175560"
        ];

        // H5收银台
        $H5_CASHIER_VSP = [
            "vspCusid" => "6602900421400PJ",
            "limitPay" => ""
        ];

        // 微信小程序收银台
        $WECHATPAY_MINIPROGRAM_CASHIER_VSP = [
            "vspCusid" => "6602900421400PJ",
            "limitPay" => "",
            "multiPay" => "",
            "isDirectPay" => "",
            "subBranch" => "",
            "isHideShare" => "",
            "cerNum" => "",
            "name" => ""
        ];

        // 支付宝小程序收银台
        $ALIPAY_MINIPROGRAM_CASHIER_VSP = [
            "vspCusid" => "6602900421400PJ",
            "limitPay" => "",
            "isDirectPay" => "",
            "subBranch" => "",
            "isHideShare" => "",
            "cerNum" => "",
            "name" => "",
            "fqNum" => ""
        ];

        // 组装支付方式
        $payMode = [
            "SCAN_WEIXIN" => $SCAN_WEIXIN,
//            "WECHAT_PUBLIC" => $WECHAT_PUBLIC,
//            "WECHATPAY_MINIPROGRAM" => $WECHATPAY_MINIPROGRAM,
//            "CODEPAY_VSP" => $CODEPAY_VSP,
//            "SCAN_ALIPAY" => $SCAN_ALIPAY,
//            "SCAN_UNIONPAY" => $SCAN_UNIONPAY,
//            "ALIPAY_SERVICE" => $ALIPAY_SERVICE,
//            "UNIONPAY_JS" => $UNIONPAY_JS,
//            "ORDER_VSPPAY" => $ORDER_VSPPAY,
//            "H5_CASHIER_VSP" => $H5_CASHIER_VSP,
//            "WECHATPAY_MINIPROGRAM_CASHIER_VSP" => $WECHATPAY_MINIPROGRAM_CASHIER_VSP,
//            "ALIPAY_MINIPROGRAM_CASHIER_VSP" => $ALIPAY_MINIPROGRAM_CASHIER_VSP,
//            "QUICKPAY_SFT" => $QUICKPAY_SFT,
//            "QUICKPAY_VSP" => $QUICKPAY_VSP
        ];
        // 订单过期时间
        $orderValidTime = date('Y-m-d H:i:s', strtotime('+720 minutes'));

        // 组装参数
        $bizParameter = new BizParameter();
        $bizParameter->addParam("reqTraceNum", TxUtils::genReqTraceNum() . "2085"); // 商户订单号
        $bizParameter->addParam("orderAmount", 2); // 订单金额
        $bizParameter->addParam("payAmount", 2); // 支付金额
        $bizParameter->addMapParam("payMode", $payMode); // 支付模式
        $bizParameter->addParam("reqsUrl", "http://www.baidu.com"); // 前台通知地址
        $bizParameter->addParam("respUrl", "http://test.allinpay.com/open/testNotify"); // 后台通知地址
        $bizParameter->addParam("orderValidTime", $orderValidTime); // 订单过期时间
        $bizParameter->addParam("goodsName", "goodsName123456"); // 商品名称
        $bizParameter->addParam("goodsDesc", "goodsDesc123456"); // 商品描述
        $bizParameter->addParam("summary", "摘要");
        $bizParameter->addParam("extendParams", json_encode(["extend" => "abcdefghiii"]));

        // 发送请求
        $txClient = new TxClient(self::$demoConfig);
        $txResponse = $txClient->sendRequest("2085", $bizParameter, self::$demoConfig->getUrl());

        // 打印响应结果
        echo PHP_EOL . "响应结果: " . $txResponse->bizData;
    }
}

// 执行主函数
Tx2085Demo::main();

